/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By:  ͵ <yokota@netlab.is.tsukuba.ac.jp>
 */
/* $Id: Xatm.h,v 1.15 1999/09/29 20:09:24 elca Exp $ */

/* Xatm.h */

#ifndef _XATM_H
#define _XATM_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>

#include <X11/Xos.h>

#define XtNumber(arr) ((unsigned int) (sizeof(arr) / sizeof(arr[0])))

#include <fntfilst.h>
#include <fontutil.h>

#include "Xatm_struct.h"
#include "metric.h"
#include "gs.h"

/* bool */
#define XATM_TRUE 1
#define XATM_FALSE 0

/* Xatm ǧեȤγĥ */
#define XATM_EXT      ".atm"
#define XATM_EXT_LEN  4


Bool FontFileRegisterRenderer (FontRendererPtr renderer);
void BitOrderInvert(register unsigned char *buf, register int nbytes);
void TwoByteSwap(register unsigned char *buf, register int nbytes);
void FourByteSwap(register unsigned char *buf, register int nbytes);
int CheckFSFormat(fsBitmapFormat format,
		  fsBitmapFormatMask fmask,
		  int *bit_order,
		  int *byte_order,
		  int *scan,
		  int *glyph,
		  int *image);
Atom MakeAtom(char *string, unsigned len, int makeit);
int FontDefaultFormat (int *bit, int *byte, int *glyph, int *scan);
            /* δؿ void ˸Τ... -> fontfile/defaults.c */
void CleanupChild(int n); /* programs/xfs/os/utils.c */
FontPtr CreateFontRec(void); /* lib/font/util/private.c */
void DestroyFontRec(FontPtr pFont); /* lib/font/util/private.c */


/* δؿϼºݤȰ㤦, ưϤ */
void Xfree (void *n);



/* fcntl.c */
void xatm_nonblock(int fd);
void xatm_block(int fd);
void xatm_flush(int fd);

/* util.c */
char * strcasestr(char *haystack, const char *needle);
int xatm_get_fontname(const char *filename, char *fontname);
int xatm_get_capname(const char *filename, char *capname);

/* pool.c */
CharInfoPoolPtr CharInfoPool_Alloc(int bitmapSize);
CharInfoPtr CharInfoPool_Get(CharInfoPoolPtr this);
void CharInfoPool_Free(CharInfoPoolPtr this);

/* Xatm_funcs.c */
int XatmOpenScalable(FontPathElementPtr fpe,
		     FontPtr	    *pFont,
		     int                flags,
		     FontEntryPtr       entry,
		     const char         *fileName,
		     FontScalablePtr    vals,
		     fsBitmapFormat     format,
		     fsBitmapFormatMask fmask,
		     FontPtr            non_cachable_font);
int XatmGetInfoScalable(FontPathElementPtr  fpe,
			FontInfoPtr	    pFontInfo,
			FontEntryPtr        entry,
			FontNamePtr	    pFontName,
			const char	    *fileName,
			FontScalablePtr	vals);
void XatmRegisterFontFileFunctions(void);

/* caps.c */
int xatm_caps_change(const char *capname,
		     FontEntryPtr    entry,
		     FontScalablePtr vals);
int xatm_caps_change_xatm(const char *capname,
			  FontEntryPtr entry,
			  XatmFontPtr  xatm);

#endif
